/*******************************************************************

PWM:
  

******************************************************************/

#include <reg167.h>
#include <stdio.h>
#include <math.h>
#include <intrins.h>


sbit P310 = P3^10; 
sbit DP310 = DP3^10;      
sbit P700 = P7^00;
sbit DP700 = DP7^00;

	
/******************************************************************/

void pwmint (void) interrupt 0x3F
   {
	
	PIR0=0;
	T3=512;
    T3R=1;        //Start Timer 3
   	}
/******************************************************************/


void t3int (void) interrupt 0x23
/* timer T3 overflow */
 	{
	T3R=0;			// T3 stop

    ADST=1;        //ADSTART
    while (ADBSY);
    
    PW0=1841-(ADDAT & 0x03ff);  //ADDAT-A/D converter result register, 10 bit mask
 
    }
/******************************************************************/


void main (void) {
// Initialisation

// Serial Port


   P310=1;         // set Port 3.10 output latch TxD 
   DP310=1;        // set Port 3.10 direction control TxD out      
   S0TIC=0x80;     // set transmit interrupt flag
   S0RIC=0x00;     // reset receive interrupt flag
   S0BG= 0x33;     // set baudrate 9600 @ 16 MC CPU clock
   S0CON=0x8011;   // set serial mode
                   
// Pulse Width Modulation Unit

P700=1;           // Inverted Output
DP700=1;          // Pulse Width Output at Pin 7.0
PP0=1023;   	  // Period Register
PW0=818;          // Low Pulse Width
PWMCON0=0x0111;   // RUN 1/64 fCPU 244 Hz Interrupt Request flag enable      
PWMCON1=0x0001;   // Output enable at Pin 7.0

// Timer 3

T3CON=0x0083;     // 1/64 fCPU, count down, Run Disable

// Interrupts

PWMIC=0x44;        // PWM int enable		ILVL=1 GLVL=0
T3IC= 0x45;        // Timer 3 int enable    ILVL=1 GLVL=1

//AD converter

ADCON=0x0000;


puts("OK\n");
IEN=1;

while(1) _idle_();

}
